library winscard;

{$DEFINE WinSCard_DYNLINK}

uses
  SysUtils,
  Classes, Types, Windows, WinSCardLib;

{$R *.res}

var
  aFile : TFileStream;

procedure Log(aMsg : String);
begin
  aMsg := aMsg + #13#10;
  aFile.Write(PChar(aMsg)^, Length(aMsg));
end;


function StrToHex(aData : Pointer; aLen : Integer) : String; overload;
Var
  I : Integer;
begin
  Result := '';
  for I := 0 to aLen-1 do
    Result := Result + IntToHex(PByteArray(aData)[I], 2)+' ';
  Delete(Result, Length(Result), 1);
end;

function StrToHex(aStr : String) : String; overload;
Var
  I : Integer;
begin
  Result := '';
  for I := 1 to Length(aStr) do
    Result := Result + IntToHex(Byte(aStr[I]),2)+' ';
  Delete(Result, Length(Result), 1);
end;

function SCardEstablishContext(dwScope: DWORD; pvReserved1: Pointer; pvReserved2: Pointer; phContext: Pointer): LongInt; stdcall;
begin
  Log('Call SCardEstablishContext');
  Result := WinSCardLib.SCardEstablishContext(dwScope, pvReserved1, pvReserved2, phContext);
end;

function SCardReleaseContext(hContext: LongInt): LongInt; stdcall;
begin
  Log('Call SCardReleaseContext');
  Result := WinSCardLib.SCardReleaseContext(hContext);
end;

function SCardListReaderGroupsA(hContext: LongInt; mszGroups: LPStr; var pcchGroups: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListReaderGroupsA');
  Result := WinSCardLib.SCardListReaderGroups(hContext, mszGroups, pcchGroups);
end;

function SCardListReaderGroupsW(hContext: LongInt; mszGroups: LPWStr; var pcchGroups: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListReaderGroupsW');
end;

function SCardListReadersA(SCARDCONTEXT: LongInt; mszGroups: LPStr; mszReaders: LPStr; var pcchReaders: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListReadersA');
  Result := WinSCardLib.SCardListReaders(SCARDCONTEXT, mszGroups, mszReaders, pcchReaders);
end;

function SCardListReadersW(SCARDCONTEXT: LongInt; mszGroups: LPWStr; mszReaders: LPWStr;
                              var pcchReaders: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListReadersW');
end;

function SCardListCardsA(hContext: LongInt; var pbAtr: Byte; var rgguidInterfaces: GUID;
                            cguidInterfaceCount: LongInt; mszCards: LPStr; var pcchCards: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListCardsA');
  Result := WinSCardLib.SCardListCards(hContext, pbAtr, rgguidInterfaces, cguidInterfaceCount, mszCards, pcchCards);
end;

function SCardListCardsW(hContext: LongInt; var pbAtr: Byte; var rgguidInterfaces: GUID;
                            cguidInterfaceCount: LongInt; mszCards: LPWStr; var pcchCards: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListCardsW');
end;

function SCardListInterfacesA(hContext: LongInt; szCard: LPStr; var pguidInterfaces: GUID;
                                var pcguidInterfaces: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListInterfacesA');
  Result := WinSCardLib.SCardListInterfaces(hContext, szCard, pguidInterfaces, pcguidInterfaces);
end;

function SCardListInterfacesW(hContext: LongInt; szCard: LPWStr; var pguidInterfaces: GUID;
                                 var pcguidInterfaces: LongInt): LongInt; stdcall;
begin
  Log('Call SCardListInterfacesW');
end;

function SCardGetProviderIdA(hContext: LongInt; szCard: LPStr; var pguidProviderId: GUID): LongInt; stdcall;
begin
  Log('Call SCardGetProviderIdA');
  Result := WinSCardLib.SCardGetProviderId(hContext, szCard, pguidProviderId);
end;

function SCardGetProviderIdW(hContext: LongInt; szCard: LPWStr; var pguidProviderId: GUID): LongInt; stdcall;
begin
  Log('Call SCardGetProviderIdW');
end;

function SCardGetCardTypeProviderNameA(hContext: LongInt; szCardName: LPStr; dwProviderId: LongInt;
                                          szProvider: LPStr; var pcchProvider: LongInt): LongInt; stdcall;
begin
  Log('Call SCardGetCardTypeProviderNameA');
  Result := WinSCardLib.SCardGetCardTypeProviderName(hContext, szCardName, dwProviderId, szProvider, pcchProvider);
end;

function SCardGetCardTypeProviderNameW(hContext: LongInt; szCardName: LPWStr; dwProviderId: LongInt;
                                          szProvider: LPWStr; var pcchProvider: LongInt): LongInt; stdcall;
begin
  Log('Call SCardGetCardTypeProviderNameW');
end;

function SCardIntroduceReaderGroupA(hContext: LongInt; szGroupName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardIntroduceReaderGroupA');
  Result := WinSCardLib.SCardIntroduceReaderGroup(hContext, szGroupName);
end;

function SCardIntroduceReaderGroupW(hContext: LongInt; szGroupName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardIntroduceReaderGroupW');
end;

function SCardForgetReaderGroupA(hContext: LongInt; szGroupName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardForgetReaderGroupA');
  Result := WinSCardLib.SCardForgetReaderGroup(hContext, szGroupName);
end;

function SCardForgetReaderGroupW(hContext: LongInt; szGroupName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardForgetReaderGroupW');
end;

function SCardIntroduceReaderA(hContext: LongInt; szReadeName: LPStr; szDeviceName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardIntroduceReaderA');
  Result := WinSCardLib.SCardIntroduceReader(hContext, szReadeName, szDeviceName);
end;

function SCardIntroduceReaderW(hContext: LongInt; szReadeName: LPWStr; szDeviceName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardIntroduceReaderW');
end;

function SCardForgetReaderA(hContext: LongInt; szReaderName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardForgetReaderA');
  Result := WinSCardLib.SCardForgetReader(hContext, szReaderName);
end;

function SCardForgetReaderW(hContext: LongInt; szReaderName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardForgetReaderW');
end;

function SCardAddReaderToGroupA(hContext: LongInt; szReaderName: LPStr; szGroupName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardAddReaderToGroupA');
  Result := WinSCardLib.SCardAddReaderToGroup(hContext, szReaderName, szGroupName);
end;

function SCardAddReaderToGroupW(hContext: LongInt; szReaderName: LPWStr; szGroupName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardAddReaderToGroupW');
end;

function SCardRemoveReaderFromGroupA(hContext: LongInt; szReaderName: LPStr; szGroupName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardRemoveReaderFromGroupA');
  Result := WinSCardLib.SCardRemoveReaderFromGroup(hContext, szReaderName, szGroupName);
end;

function SCardRemoveReaderFromGroupW(hContext: LongInt; szReaderName: LPWStr; szGroupName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardRemoveReaderFromGroupW');
end;

function SCardIntroduceCardTypeA(hContext: LongInt; szCardName: LPStr; var pguidPrimaryProvider: GUID;
                                    var pguidInterfaces: GUID; dwInterfaceCount: LongInt; pbAtr: LPStr;
                                    pbAtrMask: LPStr; cbAtrLen: LongInt): LongInt; stdcall;
begin
  Log('Call SCardIntroduceCardTypeA');
  Result := WinSCardLib.SCardIntroduceCardType(hContext, szCardName, pguidPrimaryProvider, pguidInterfaces, dwInterfaceCount, pbAtr, pbAtrMask, cbAtrLen);
end;

function SCardIntroduceCardTypeW(hContext: LongInt; szCardName: LPWStr; var pguidPrimaryProvider: GUID;
                                    var pguidInterfaces: GUID; dwInterfaceCount: LongInt; pbAtr: LPWStr;
                                    pbAtrMask: LPWStr; cbAtrLen: LongInt): LongInt; stdcall;
begin
  Log('Call SCardIntroduceCardTypeW');
end;

function SCardSetCardTypeProviderNameA(hContext: LongInt; szCardName: LPStr; dwProviderId: LongInt;
                                          szProvider: LPStr): LongInt; stdcall;
begin
  Log('Call SCardSetCardTypeProviderNameA');
  Result := WinSCardLib.SCardSetCardTypeProviderName(hContext,szCardName, dwProviderId, szProvider);
end;

function SCardSetCardTypeProviderNameW(hContext: LongInt; szCardName: LPWStr; dwProviderId: LongInt;
                                          szProvider: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardSetCardTypeProviderNameW');
end;

function SCardForgetCardTypeA(hContext: LongInt; szCardName: LPStr): LongInt; stdcall;
begin
  Log('Call SCardForgetCardTypeA');
  Result := WinSCardLib.SCardForgetCardType(hContext, szCardName);
end;

function SCardForgetCardTypeW(hContext: LongInt; szCardName: LPWStr): LongInt; stdcall;
begin
  Log('Call SCardForgetCardTypeW');
end;

function SCardFreeMemory(hContext: LongInt; pvMem: LongInt): LongInt; stdcall;
begin
  Log('Call SCardFreeMemory');
  Result := WinSCardLib.SCardFreeMemory(hContext, pvMem);
end;

function SCardLocateCardsA(hContext: LongInt; mszCards: LPStr; var rgReaderStates: PSCARD_READERSTATEA;
                              cReaders: LongInt): LongInt; stdcall;
begin
  Log('Call SCardLocateCardsA');
  Result := WinSCardLib.SCardLocateCards(hContext,mszCards, rgReaderStates, cReaders);
end;

function SCardLocateCardsW(hContext: LongInt; mszCards: LPWStr; var rgReaderStates: PSCARD_READERSTATEW;
                              cReaders: LongInt): LongInt; stdcall;
begin
  Log('Call SCardLocateCardsW');
end;

function SCardGetStatusChangeA(    hContext:       WinSCardLib.SCARDCONTEXT;
                                      dwTimeout:      LongInt;
                                  var rgReaderStates: PSCARD_READERSTATEA;
                                      cReaders:       LongInt): LongInt; stdcall;
begin
  Log('Call SCardGetStatusChangeA');
  Result := WinSCardLib.SCardGetStatusChange(hContext, dwTimeout, rgReaderStates, cReaders);
end;

function SCardGetStatusChangeW(hContext: LongInt; dwTimeout: LongInt; var rgReaderStates: PSCARD_READERSTATEW;
                                  cReaders: LongInt): LongInt; stdcall;
begin
  Log('Call SCardGetStatusChangeW');
end;

function SCardCancel (hContext: LongInt): LongInt; stdcall;
begin
  Log('Call SCardCancel');
  Result := WinSCardLib.SCardCancel(hContext);
end;

function SCardConnectA(hContext: LongInt; szReader: LPStr; dwShareMode: LongInt; dwPreferredProtocols: LongInt;
                          var phCard: LongInt; pdwActiveProtocol: PDword): LongInt; stdcall;
begin
  Log('Call SCardConnectA');
  Result := WinSCardLib.SCardConnect(hContext, szReader, dwShareMode, dwPreferredProtocols, phCard, pdwActiveProtocol); 
end;

function SCardConnectW(hContext: LongInt; szReader: LPWStr; dwShareMode: LongInt; dwPreferredProtocols: LongInt;
                          var phCard: LongInt; pdwActiveProtocol: PDword): LongInt; stdcall;
begin
  Log('Call SCardConnectW');
end;

function SCardReconnect(hCard: LongInt; dwShareMode: LongInt; dwPreferredProtocols: LongInt;
                           dwInitialization: LongInt; var pdwActiveProtocol: LongInt): LongInt; stdcall;
begin
  Log('Call SCardReconnect');
  Result := WinSCardLib.SCardReconnect(hCard, dwShareMode, dwPreferredProtocols, dwInitialization, pdwActiveProtocol);
end;

function SCardDisconnect(hCard: LongInt; dwDisposition: LongInt): LongInt; stdcall;
begin
  Log('Call SCardDisconnect');
  Result := WinSCardLib.SCardDisconnect(hCard,dwDisposition);
end;

function SCardBeginTransaction(hCard: LongInt): LongInt; stdcall;
begin
  Log('Call SCardBeginTransaction');
  Result := WinSCardLib.SCardBeginTransaction(hCard);
end;

function SCardEndTransaction(hCard: LongInt; dwDisposition: LongInt): LongInt; stdcall;
begin
  Log('Call SCardEndTransaction');
  Result := WinSCardLib.SCardEndTransaction(hCard, dwDisposition);
end;

function SCardStatusA(hCard: LongInt; mszReaderNames: LPStr; var pcchReaderLen: LongInt; var pdwState: LongInt;
                         pdwProtocol: PDWord; pbAtr: PByte; var pcbAtrLen: LongInt): LongInt; stdcall;
begin
  Log('Call SCardStatusA');
  Result := WinSCardLib.SCardStatus(hCard, mszReaderNames, pcchReaderLen, pdwState, pdwProtocol, pbAtr, pcbAtrLen);
end;


function SCardStatusW(hCard: LongInt; mszReaderNames: LPWStr; var pcchReaderLen: LongInt; var pdwState: LongInt;
                         pdwProtocol: PDWord; pbAtr: PByte; var pcbAtrLen: LongInt): LongInt; stdcall;
begin
  Log('Call SCardStatusW');
end;

function SCardTransmit(hCard: LongInt; pioSendPci: Pointer; pbSendBuffer: PByte;
                          dwSendLength: DWORD; pioRecvPci: Pointer; pbRecvBuffer: PByte;
                          pcbRecvLength: PDWord): LongInt; stdcall;
Var
  aSend : String;
  aRecv : String;
  aMsg : String;                          
begin
  aMsg := 'Call SCardTransmit(hCard:'+IntToStr(hCard)+',pioSendPci:';
  if(pioSendPci=nil) then
    aMsg := aMsg + 'nil'
  else
  begin
    aMsg := aMsg + '(Protocol:'+IntToStr(SCARD_IO_REQUEST(pioSendPci^).dwProtocol)+', PciLength:'+IntToStr(SCARD_IO_REQUEST(pioSendPci^).dbPciLength)+')';
  end;
  Log(aMsg+')');

  Log('  >> '+ StrToHex( pbSendBuffer ,dwSendLength ));

  Result := WinSCardLib.SCardTransmit(hCard, pioSendPci, pbSendBuffer, dwSendLength, pioRecvPci, pbRecvBuffer, pcbRecvLength);

  Log('  << '+ StrToHex( pbRecvBuffer ,pcbRecvLength^  ));
end;

function SCardControl(hCard: LongInt; dwControlCode: LongInt; var pvInBuffer: PByte; cbInBufferSize: LongInt;
                         var pvOutBuffer: PByte; cbOutBufferSize: LongInt;
                         var pcbBytesReturned: LongInt): LongInt; stdcall;
begin
  Log('Call SCardControl');
  Result := WinSCardLib.SCardControl(hCard,dwControlCode, pvInBuffer, cbInBufferSize, pvOutBuffer, cbOutBufferSize, pcbBytesReturned);
end;

function SCardGetAttrib(hCard: LongInt; dwAttrId: LongInt; pbAttr: PByte; pcbAttrLen: LongInt): LongInt; stdcall;
begin
  Log('Call SCardGetAttrib');
  Result := WinSCardLib.SCardGetAttrib(hCard, dwAttrId, pbAttr, pcbAttrLen);
end;

function SCardSetAttrib(hCard: LongInt; dwAttrId: LongInt; var pbAttr: PByte; cbAttrLen: LongInt): LongInt; stdcall;
begin
  Log('Call SCardSetAttrib');
  Result := WinSCardLib.SCardSetAttrib(hCard, dwAttrId, pbAttr, cbAttrLen);
end;

function SCardLocateCardsByATRA(hContext: LongInt; rgAtrMasks: LPSCARD_ATRMASK; cAtrs: DWORD;
                                   var rgReaderStates: SCARD_READERSTATEA; cReaders: DWORD): LongInt; stdcall;
begin
  Log('Call SCardLocateCardsByATRA');
  Result := WinSCardLib.SCardLocateCardsByATR(hContext, rgAtrMasks, cAtrs, rgReaderStates, cReaders);
end;

function SCardLocateCardsByATRW(hContext: LongInt; rgAtrMasks: LPSCARD_ATRMASK; cAtrs: DWORD;
                                   var rgReaderStates: SCARD_READERSTATEW; cReaders: DWORD): LongInt; stdcall;
begin
  Log('Call SCardLocateCardsByATRW');
end;

function SCardAccessStartedEvent: LongInt; stdcall;
begin
  Log('Call SCardAccessStartedEvent');
  Result := WinSCardLib.SCardAccessStartedEvent;
end;

function SCardReleaseStartedEvent: LongInt; stdcall;
begin
  Log('Call SCardReleaseStartedEvent');
  Result := WinSCardLib.SCardReleaseStartedEvent;
end;

function SCardIsValidContext(hContext: LongInt): LongInt; stdcall;
begin
  Log('Call SCardIsValidContext');
  Result := WinSCardLib.SCardIsValidContext(hContext);
end;




exports
 SCardEstablishContext,
 SCardReleaseContext,
 SCardListReaderGroupsW,
 SCardListReaderGroupsA,
 SCardListReadersW,
 SCardListReadersA,
 SCardListCardsW,
 SCardListCardsA,
 SCardListInterfacesW,
 SCardListInterfacesA,
 SCardGetProviderIdW,
 SCardGetProviderIdA,
 SCardGetCardTypeProviderNameW,
 SCardGetCardTypeProviderNameA,
 SCardIntroduceReaderGroupW,
 SCardIntroduceReaderGroupA,
 SCardForgetReaderGroupW,
 SCardForgetReaderGroupA,
 SCardIntroduceReaderW,
 SCardIntroduceReaderA,
 SCardForgetReaderW,
 SCardForgetReaderA,
 SCardAddReaderToGroupW,
 SCardAddReaderToGroupA,
 SCardRemoveReaderFromGroupW,
 SCardRemoveReaderFromGroupA,
 SCardIntroduceCardTypeW,
 SCardIntroduceCardTypeA,
 SCardSetCardTypeProviderNameW,
 SCardSetCardTypeProviderNameA,
 SCardForgetCardTypeW,
 SCardForgetCardTypeA,
 SCardFreeMemory,
 SCardLocateCardsW,
 SCardLocateCardsA,
 SCardGetStatusChangeW,
 SCardGetStatusChangeA,
 SCardCancel,
 SCardConnectW,
 SCardConnectA,
 SCardReconnect,
 SCardDisconnect,
 SCardBeginTransaction,
 SCardEndTransaction,
 SCardStatusW,
 SCardStatusA,
 SCardTransmit,
 SCardControl,
 SCardGetAttrib,
 SCardSetAttrib,
 SCardIsValidContext,
 SCardLocateCardsByATRW,
 SCardLocateCardsByATRA,
 SCardAccessStartedEvent,
 SCardReleaseStartedEvent;

begin
  aFile := TFileStream.Create('irre', fmCreate);
end.
